#include "device.h"
#include "system.h"

void EnableM0SlaveTrigger();
void Init_M0GPIO();

#define MBOX0_PORT0_MEM             0x400d4000                                   // Base address of MBOX Port1 Memory
#define ptr_MBOX0_PORT0_MEM        ((volatile unsigned int*)MBOX0_PORT0_MEM)   

int main()
{
  //System Init
  SystemInit();

  //Enable M0 Slave Trigger
  EnableM0SlaveTrigger();
  
  //Initialize GPIO
  Init_M0GPIO();
       
  //Initialize interrupts
  adi_nvic_EnableInt(INTR_TRU0_INT1, 1);
  
  //wait
  while(1)
  {
    asm("NOP;");
    asm("NOP;");
  }
  
  
  return 0;
}

void TRU0_INT1_Handler()
{
  unsigned int *index = (unsigned int *)MBOX0_PORT0_MEM;
  while(!*index);
  *index = 0;
}

void Init_M0GPIO()
{
  *pREG_PORTA_FER_CLR  = BITM_PORT_FER_CLR_PX13;
  *pREG_PORTA_DIR_SET  = BITM_PORT_DIR_SET_PX13; 
  *pREG_PORTA_DATA_SET = BITM_PORT_DATA_CLR_PX13; 
}    


void EnableM0SlaveTrigger()
{
  *pREG_TRU0_GCTL       = 0x1;
  *pREG_PORTA_TRIG_TGL  = BITM_PORT_TRIG_TGL_PX13;
  *pREG_TRU0_SSR17      = TRGM_TRU1_GTP0;
  *pREG_TRU0_SSR42      = TRGM_TRU1_GTP0;  
}
